#define EXTENDERVERSION 10100          // DLL version number.  Increment this with each different version

#define INTERFACELEVEL  2              // extender interface level (DON'T CHANGE!)
#define EXTENDER_FEATURE_LEVEL 1001    // extender feature level (DON'T CHANGE)

#define STRICT                         // only if you prototype carefully

/****************************************************************************
*                                                                           *
*   The  WORDGET   winbatch extender.                                       *
*                                                                           *
*   Used to parse strings with multiple delimiters, and (possibly)          *
*   words in quotes.                                                        *
*                                                                           *
****************************************************************************/

void DebugType(char *Title, char Type);

/* -------------------------------------------------------------------------
                                    Includes
   ------------------------------------------------------------------------- */

                          // Standard Windows include
#include <windows.h>


                          // Special platform-dependent includes
#include "wwwpform.h"
#include "addons.h"

/*---------------------------------------------------------------------------+
!                             Defines                                        !
+---------------------------------------------------------------------------*/


    // helpful functions for displaying debugging message boxes
#define MBSS(p1, p2) {MessageBox(GetFocus(), (p2), (p1), MB_OK | MB_SETFOREGROUND);}
#define MBSN(p1, p2) {char szDebug[20]; wsprintf(szDebug,"%d",(long)(p2)); MessageBox(GetFocus(), szDebug, (p1), MB_OK | MB_SETFOREGROUND);}

   // RETLONG passes its argument back as the return value
   // of the function, and returns to the WIL Interpreter.

#define RETLONG(numb)         return (lpViperCallback(((lpViperReturn->x=numb)      +(lpViperReturn->inittype=VARTYPE_INT))      ?RESULT_SUCCESS:RESULT_SUCCESS, ViperInterfaceVersion, lpViperStruct, lpViperReturn))

   // RETFLOAT passes its argument back as the return value ,
   // of the function,  and returns to the WIL Interpreter.

#define RETFLOAT(numb)        return (lpViperCallback(((lpViperReturn->flt=numb)    +(lpViperReturn->inittype=VARTYPE_FLOATNUM)) ?RESULT_SUCCESS:RESULT_SUCCESS, ViperInterfaceVersion, lpViperStruct, lpViperReturn))

   // RETSTRING passes its argument back as the return value
   // of the function, and returns to the WIL Interpreter.

#define RETSTRING(str)        return (lpViperCallback(((lpViperReturn->lpstr=str)   +(lpViperReturn->inittype=VARTYPE_STRING))   ?RESULT_SUCCESS:RESULT_SUCCESS, ViperInterfaceVersion, lpViperStruct, lpViperReturn))

   // RETERROR(level,rcfilestringid) passes back an error massage
   // to the WIL interpreter.
   //   level MUST be...  -1 for most run of the mill errors.
   //                     -2 for serious errors
   //                     -3 for absolutely fatal "we better die" errors
   //   rcstringid is the string ID from the RC file that contains the
   //   error message.  The first three characters of the string should
   //   be the same as the string ID, & the 4th character should be a colon.

#define RETERROR(sev, errnum) return (lpViperCallback(((LoadString(hinstDLL, (errnum), lpViperReturn->lpstr = szWork, sizeof(szWork)))+(lpViperReturn->inittype = VARTYPE_STRING)) ?(sev)         :(sev)         , ViperInterfaceVersion, lpViperStruct, lpViperReturn))


   // ANSWERSTRING passes its string argument back as the function return, but
   // does not return to the WIL program.  NOTE: The value that is returned by
   // ANSWERSTRING must be the value you use in your own 'return' command.

#define ANSWERSTRING(str) lpViperCallback(  ((lpViperReturn->lpstr=str)+(lpViperReturn->inittype=VARTYPE_STRING))?RESULT_SUCCESS:RESULT_SUCCESS,ViperInterfaceVersion,lpViperStruct,lpViperReturn)
#define ANSWERLONG(numb)  lpViperCallback(  ((lpViperReturn->x=numb)+(lpViperReturn->inittype=VARTYPE_INT))?RESULT_SUCCESS:RESULT_SUCCESS,ViperInterfaceVersion,lpViperStruct,lpViperReturn)
#define ANSWERFLOAT(numb) lpViperCallback(  ((lpViperReturn->flt=numb)+(lpViperReturn->inittype=VARTYPE_FLOATNUM))?RESULT_SUCCESS:RESULT_SUCCESS,ViperInterfaceVersion,lpViperStruct,lpViperReturn)

   // RETCANCEL returns a Cancel flag

#define RETCANCEL return (-5)



/*---------------------------------------------------------------------------+
!       Definitions used when manipulating arrays.                           !
+---------------------------------------------------------------------------*/
#define VARTYPE_UNDEF      0           // These are bitmapped, var can be both
#define VARTYPE_INT        1           // Numeric and string, must check bits
#define VARTYPE_STRING     2
#define VARTYPE_FILE       5           // FILE and INT bits set
#define VARTYPE_UNINIT     8
#define VARTYPE_OLEOBJECT 17           // OLE AND INT bits set
#define VARTYPE_FLOATNUM  32           // floating point
#define VARTYPE_BINARY    65           // BINARY and INT bits set
#define VARTYPE_XOLEOBJECT 129         /// an OLE object that has been temporarily camouflaged
#define VARTYPE_ARRAY     256          /// an array

typedef struct arrayvariable
{
  double Aflt;                         // 8-byte floating point number
  LONG   Ax;                           // if int variable, value is here
  int    Ainittype;                    // 0=uninitialized 1=int 2=string 3=both  yes can have both sometimes
  DWORD  Astrptr;                      // pointer to string space for string
} arrvar;


typedef struct resultants2
{
  union u
  {
    struct s                           // for normal variables
    {
      double flt;                      // 8-byte floating point number
      LONG   x;                        // if int variable, value is here
    };
    struct ss                          // for VARTYPE_ARRAY
    {
      WORD wDim[5];                    // array dimension sizes
      BYTE cDims;                      // number of array dimensions
      BYTE cFlags;                     // array flags
    };
  };
  int   inittype;                      // 0=uninitialized 1=int 2=string 3=both  yes can have both sometimes
  union uu
  {
    DWORD strptr;                      // pointer to string space for string
    LPSTR lpBuffer;                    // pointer to locked array data buffer for VARTYPE_ARRAY
  };
  WORD  vorigin;                       // index to var area is derived from var, or FFFF
} resultvar2;

typedef arrvar FAR *LPARRVAR;

typedef resultvar2 FAR * LPRESULTVAR2;




/*---------------------------------------------------------------------------+
!       Parameter block for called routines                                  !
+---------------------------------------------------------------------------*/
typedef struct xCommonStruct
{
     long        Long;       /* Numeric value (when return = 'L'            */
     char        *String;    /* String        (when return = 'S' or 'E')    */
     resultvar2  Array;      /* Array         (when return = 'A')           */
     char        *Buffer;    /* Memory Buffer                               */
     long        BuffSize;   /* Size of Buffer                              */
     BOOL        Borrowed;   /* Is buffer borrowed memory?                  */
     long        ErrorType;  /* Error type... -1 (Normal) or -3 (Fatal)     */
     char        Type;       /* A = Array, S = String, L = Long, E = Error. */
} xCommon;




/*---------------------------------------------------------------------------+
!                            Function Prototypes                             !
+---------------------------------------------------------------------------*/
BOOL WINAPI DllMain(HANDLE hInst, DWORD dwReason, LPVOID lpReserved);

LONG  NEARPASCAL Atol(LPSTR);
void  NEARPASCAL Ltoa(LONG nNum, LPSTR lpDest, UINT nBase);
BOOL  NEARPASCAL IsNumber(LPSTR);
BOOL  NEARPASCAL DebugMessage(HWND, LPSTR, LPSTR, BOOL);
BOOL  NEARPASCAL GetBuffer(xCommon *Common, long Size);
char  NEARPASCAL *GetWord(char *String, char *DelimList, xCommon *Common, char *Delim);
BOOL  SetArrayString(xCommon *Common, LPARRVAR lpArray, char *TheString);


/*---------------------------------------------------------------------------+
!                              Global Variables                              !
+---------------------------------------------------------------------------*/

/* Superstitious data field to bypass/ignore bugs in certain versions of
   Windows that cause the beginning of the data area to be overwritten.
   This field should be the first data area defined and linked. */
char szBugFiller[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";

HINSTANCE   hinstDLL;                    // DLL Instance saved
DLLSERVICES lpfnDllServices = NULL;
HGLOBAL     hBatData = NULL;


/*---------------------------------------------------------------------------+
!                        Command Extension Table                             !
+----------------------------------------------------------------------------+
!                                                                            !
! ID   Type       Mask               Params/Value Size Name                  !
+----------------------------------------------------------------------------*/
tablestruct CommandExtTable[] =
{
  {10,  FUNCTION,  0x0000000000000000, 0x00000001L,  0, "wordgetinfo"   }, // WordGetInfo(n)
  {11,  FUNCTION,  0x0000000000000110, 0x00000003L,  0, "wordget"       }, // WordGet(n,s,s)
  {12,  FUNCTION,  0x0000000000000110, 0x00000003L,  0, "wordremove"    }, // WordRemove(n,s,s)
  {13,  FUNCTION,  0x0000000000000110, 0x00000003L,  0, "worddelimiter" }, // WordDelimiter(n,s,s)
  {14,  FUNCTION,  0x0000000000000011, 0x00000002L,  0, "wordcount"     }, // WordCount(s,s)
  {15,  FUNCTION,  0x0000000000000011, 0x00000102L,  0, "wordarray"     }, // WordArray(s,s)
//--------------------------------------------------------------------------
  {-1,         0,   0x000000000000000, 0x00000000L,  0,  ""             }
};


/*****************************************************************************
*                                                                            *
*                                  DllMain                                   *
*                                                                            *
*****************************************************************************/
BOOL WINAPI DllMain(HANDLE hInst, DWORD dwReason, LPVOID lpReserved)
{

  hinstDLL = hInst;
  UNREFERENCED_PARAMETER(dwReason);
  UNREFERENCED_PARAMETER(lpReserved);
  return (TRUE);
}


/*****************************************************************************
*                               WILExtenderQuery                             *
*                                                                            *
*  WILExtenderQuery provides helpful information to the WIL DLL.             *
*****************************************************************************/

DllExport LONG FAR PASCAL WILExtenderQuery
 (short  nRequest,                     // type of information being requested
  LPVOID lpvInfo,                      // information buffer
  LONG   nCount)                       // additional data
{
  char szWork[256];
  LONG        i;

  switch (nRequest)
  {
/*-----------------------------------------------------------------------------+
!  case 1 is used to identify yourself to a caller.                            !
!                                                                              !
!  If lpvInfo is not NULL, it points to a character buffer where you may copy  !
!  a string describing the extender.                                           !
!                                                                              !
!  nCount is the size of the buffer pointed to by lpvInfo, in bytes.  When     !
!  called by the WIL DLL, you can expect this to be a 256-byte buffer.         !
!                                                                              !
!  The return value should be the version number of the extender.              !
+-----------------------------------------------------------------------------*/
    case 1:
    {
      if ((lpvInfo) && (nCount > 0))
      {
        LoadString(hinstDLL, 1000, szWork, sizeof(szWork));
        lstrcpyn((LPSTR) lpvInfo, szWork, nCount);
      }
      return (EXTENDERVERSION);
    }

/*-----------------------------------------------------------------------------+
!  case 2 is used to inform the WIL DLL of your preferred interface level.     !
!                                                                              !
!  lpvInfo points to an array of LONG's, indicating the interface levels       !
!  supported by the WIL DLL (each element represents one level).               !
!                                                                              !
!  nCount indicates the number of elements in the array pointed to by lpvInfo. !
!                                                                              !
!  The return value must be the same as one of the elements in the lpvInfo     !
!  array.  Currently, the WIL DLL supports interface levels 1 and 2, so your   !
!  return value should be 1 or 2.  Newly designed extenders (such as WILX)     !
!  use interface level 2 and have a WilExtender2 entry point.  However, it     !
!  is possible to design an extender to support multiple interface levels.     !
!                                                                              !
!  If you return an invalid value, the extender will not be loaded and the     !
!  AddExtender command will fail.                                              !
+-----------------------------------------------------------------------------*/
    case 2:
    {
      for (i = 0; i < nCount; i++)
        if (((LPLONG) lpvInfo)[i] == INTERFACELEVEL)  // found one we like
          return (INTERFACELEVEL);
      return (-1);                     // didn't find any we like
    }

/*-----------------------------------------------------------------------------+
!  Return 0 for any unknown requests, or any requests you don't handle!        !
+-----------------------------------------------------------------------------*/
    default:
      return (0);
  }
}


/*****************************************************************************
*                                                                            *
*                                WILExtender                                 *
*                                                                            *
*****************************************************************************/
\

DllExport LONG FAR PASCAL WILExtender2
  (HWND           hWnd,                  // hWnd of parent application
  HINSTANCE       hInst,                  // hInstance of parent application
  LONG            ViperInterfaceVersion,  // WIL interface version
  short           CmdId,                  // identifies extender function being called
  LPVIPERCALLBACK lpViperCallback,        // pointer to return value callback function
  LPVIPERSTRUCT   lpViperStruct,          // pointer to information structure
  LPLONG          lpLong,                 // pointer to your 32 bits
  LPVIPERVAR      lpvvArg,                // pointer to parameter array
  LONG            nArgCount,              // parameter count for lpvvArg
  LPVIPERVAR      lpViperReturn)          // pointer to return value structure
{
  static char szWork[256];                // some local storage
  xCommon Common;
  LONG   K, L, N;
  char  *Cx;


  Common.Long = 0;
  Common.String = NULL;
  Common.Buffer = szWork;
  Common.BuffSize = 256;
  Common.Borrowed = FALSE;
  Common.Type = ' ';
  Common.ErrorType = -1;


  switch (CmdId)                       // the "big switch"
  {



/*-----------------------------------------------------------------------+
!  Case -1 is called once, when your extender is loaded.  It is the      !
!  place to perform your one-time initialization tasks.  The return      !
!  value should be the number of items in your CommandExtTable           !
!  (functions and constants).                                            !
+-----------------------------------------------------------------------*/
    case -1:
    {
       lpfnDllServices = lpViperStruct->lpfnDllServices;
       hBatData = lpViperStruct->hBatData;
       N = (sizeof(CommandExtTable) / sizeof(tablestruct)) - 1; // 1 extra at end
       return (N);
    }

/*-----------------------------------------------------------------------+
!  Case -2 is called repeatedly by the WIL extender. On each call,       !
!   one CommandTable entry is passed back to the WIL extender.           !
+-----------------------------------------------------------------------*/
    case -2:
    {
      LPTABLESTRUCT lpTable;
      UINT          j;

      lpTable = (LPTABLESTRUCT) lpvvArg;
      j = (UINT) nArgCount;

      if (CommandExtTable[j].ident == -1)
        return (0);

      if (lpTable)
      {
        lpTable->ident  = CommandExtTable[j].ident;
        lpTable->type   = CommandExtTable[j].type;
        lpTable->param1 = CommandExtTable[j].param1;
        lpTable->ulMask = CommandExtTable[j].ulMask;
        lpTable->size   = lstrlen((LPSTR) CommandExtTable[j].delim);
        CharLower(CommandExtTable[j].delim);
        lstrcpy((LPSTR) lpTable->delim, (LPSTR) CommandExtTable[j].delim);
      }

      return (1);
    }

/*-----------------------------------------------------------------------+
! Case -3 is called during the WIL shutdown process.  If you need        !
! to do any cleanup processing, do it here.                              !
+-----------------------------------------------------------------------*/
    case -3:                           // shutdown
    {
      return (1);
    }


/*-----------------------------------------------------------------------+
|                           WordGetInfo(Request#)                        |
|                                                                        |
|   Returns information on this extender                                 |
|     request: 0 = version, 1 = total functions, 2 = total constants     |
+------------------------------------------------------------------------*/
    case 10:
    {
       UINT uType;

       Common.Type = 'L';

       K = lpvvArg[0].x;
       if (K == 0)                     // extender version
       {
          Common.Long = EXTENDERVERSION;
          break;
       }

       if (K == 1)                     // total functions
            uType = FUNCTION;
       else
       {
            if (K == 2)                // total constants
                 uType = CONSTANT;
             else
             {
                 Common.Type = 'E';
                 Common.ErrorType = -1;
                 Common.Long = 101;             // invalid parameter
                 break;
             }
       }

       for (K = Common.Long = 0; CommandExtTable[K].ident != -1; K++)
          if ((UINT) CommandExtTable[K].type == uType)
              Common.Long++;

       break;

   }


/*-----------------------------------------------------------------------+
!   case 11 ... WordGet (Index, String, Delimiters)                      !
!                                                                        !
!         Scans a string of words which are separated by the listed      !
!         delimiters.  Returns a word.                                   !
!                                                                        !
!         "Index" tells which word to return.                            !
+-----------------------------------------------------------------------*/
     case 11:
     {
         N = lpvvArg[0].x;
         Common.Buffer[0] = '\0';

         Cx = lpvvArg[1].lpstr;
         for (K = 0; K < N; K++)
         {
            Cx = GetWord (Cx, lpvvArg[2].lpstr, &Common, NULL);
            if (Common.Type == 'E') break;
         }

         if (Common.Type != 'E')
         {
            Common.Type = 'S';
            Common.String = Common.Buffer;
         }
         break;
     }

/*-----------------------------------------------------------------------+
!   case 12 ... WordRemove (Index, String, Delimiters)                   !
!                                                                        !
!       Scans a string of words which are separated by the listed        !
!       delimiters.  Removes the indicated word, returns the             !
!       remainder of the string.                                         !
!                                                                        !
!       "Index" tells which to remove.                                   !
+-----------------------------------------------------------------------*/
     case 12:
     {
        char *EndLast;
        char *StartNext;

        N = lpvvArg[0].x;
        Common.Type = 'S';
        Common.Buffer[0] = '\0';

        EndLast = lpvvArg[1].lpstr;
        StartNext = EndLast;
        for (K = 0; K < N; K++)               // Find the end of the word.
        {
           EndLast = StartNext;
//         StartNext = GetWord(StartNext, lpvvArg[0].lpstr, NULL, NULL);    // This line causes a null pointer assignment error.
           StartNext = GetWord(StartNext, lpvvArg[2].lpstr, &Common, NULL); // changed DD.20030210, seems to work.
        }

        if (StartNext == NULL)                 // If we went past
        {                                      // the end of the string
             Common.String = lpvvArg[1].lpstr; // return with the
             break;                            // entire string.
        }

        K = EndLast - lpvvArg[1].lpstr;
        L = K + lstrlen(StartNext) + 2;

        if (!GetBuffer(&Common, L)) break;

        lstrcpyn(Common.Buffer,lpvvArg[1].lpstr,K+1);
        lstrcpy(Common.Buffer+K,StartNext);
        Common.String = Common.Buffer;
        break;
     }

/*-----------------------------------------------------------------------+
!   case 13 ... WordDelimiter (Index, String, Delimiters)                !
!                                                                        !
!         Scans a string of words which are separated by the listed      !
!         delimiters.  Returns the delimiter that ends a  word.          !
!                                                                        !
!         "Index" specifies which word we are searching for.             !
!         (If Index = 3, for example, we return the delimtier that       !
!         follows the third word.)                                       !
+-----------------------------------------------------------------------*/
     case 13:
     {

        N = lpvvArg[0].x;
        Common.Buffer[0] = ' ';

        Cx = lpvvArg[1].lpstr;
        for (K = 0; K < N; K++)   // Find the Delimiter after a word.
            Cx = GetWord(Cx, lpvvArg[2].lpstr, NULL, Common.Buffer);

        Common.Buffer[1] = '\0';
        Common.Type = 'S';
        Common.String = Common.Buffer;
        break;
     }


/*-----------------------------------------------------------------------+
!   case 14 ... WordCount (String, Delimiters)                           !
!                                                                        !
!         Scans a string of words which are separated by the listed      !
!         delimiters.  Returns the number of words found.                !
+-----------------------------------------------------------------------*/
     case 14:
     {

         Common.Type = 'L';       // We're returning a long integer.
         Common.Long = 0;         // Initialize the count to zero.

         Cx = lpvvArg[0].lpstr;                // The string.

         while (1)
         {
            while( *Cx == ' ') Cx++;                   // Skip leading spaces
            if (*Cx == '\0') break;                       // At end?
            Common.Long += 1;                               // No. Count a word.
            Cx = GetWord (Cx, lpvvArg[1].lpstr, NULL, NULL);   // Next word.
            if (Common.Type == 'E') break;
         }
         break;
     }



/*-----------------------------------------------------------------------+
!   case 15 ... WordArray (String, Delimiters, [,ReturnDelimiters])      !
!                                                                        !
!    Returns an array containing all the words in the string.            !
!                                                                        !
!    If ReturnDelimiters is @TRUE, then it returns a two dimensional     !
!    array, where Array[x,0] contains a word, and Array[x,1] contains    !
!    the delimiter that followed the word.                               !
!                                                                        !
!    If ReturnDelimiters is @FALSE, then it returns a one dimensional    !
!    array containing only the words.                                    !
!                                                                        !
!    ReturnDelimiters is an optional parameter. When it is omitted       !
!    the default value is @FALSE.                                        !
+-----------------------------------------------------------------------*/
     case 15:
     {
         LPARRVAR lpArray;
         BOOL     ReturnDelimiters = 0;
         char     Delimiter[2] = "x";

         if (nArgCount > 2) ReturnDelimiters = lpvvArg[2].x;

         L = 0;                   // Initialize the count to zero.
         Cx = lpvvArg[0].lpstr;   // The string.
         while (1)
         {
            while( *Cx == ' ') Cx++;            // Skip leading spaces
            if (*Cx == '\0') break;             // At end?
            L++;                                // No. Count a word.
            Cx = GetWord (Cx, lpvvArg[1].lpstr, NULL, NULL); // Next word.
            if (Common.Type == 'E') break;
         }
         if (Common.Type == 'E') break;

                                      // Get memory for an array.
        if (ReturnDelimiters)
             Common.Array.lpBuffer = GlobalAlloc(GPTR,(L+1) * 2 * sizeof(arrvar)); // 2 dimensional
        else
             Common.Array.lpBuffer = GlobalAlloc(GPTR,(L+1) * sizeof(arrvar));     // 1 dimensional

        if (Common.Array.lpBuffer == NULL)
        {
            Common.Type = 'E';        // Can't get memory?
            Common.ErrorType = -1;
            Common.Long = 913;
            break;
        }

        Common.Type = 'A';
        if (ReturnDelimiters)
        {
             Common.Array.cDims   = 2;
             Common.Array.wDim[1] = 2;
        }
        else
        {
             Common.Array.cDims   = 1;
             Common.Array.wDim[1] = 0;
        }
        Common.Array.wDim[0] = L+1;
        Common.Array.wDim[2] = 0;
        Common.Array.wDim[3] = 0;
        Common.Array.wDim[4] = 0;
        Common.Array.cFlags  = 0;
        lpArray = (LPARRVAR) Common.Array.lpBuffer;

        lpArray->Ainittype = VARTYPE_INT;
        lpArray->Ax = L;                             // Array[0,0] = count
        if (ReturnDelimiters)
        {
            lpArray++;
            lpArray->Ainittype = VARTYPE_INT;
            lpArray->Ax = 0;                         // Array[0,1] = 0
        }

        Cx = lpvvArg[0].lpstr; // The string.
        while (1)
        {
            while( *Cx == ' ') Cx++;                  // Skip leading spaces
            if (*Cx == '\0') break;                   // At end?
            Cx = GetWord (Cx, lpvvArg[1].lpstr, &Common, Delimiter); // Get Word and Delimiter
            if (Common.Type == 'E') break;

           lpArray ++;                                // Next array item is word
           if (!SetArrayString(&Common, lpArray, Common.Buffer)) break;

           if (ReturnDelimiters)
           {                                          // If we're returning delimiters
               lpArray ++;                            // Next array item is delimiter
               if (!SetArrayString(&Common, lpArray, Delimiter)) break;
           }
        }
        break;
    }
/*-----------------------------------------------------------------------+
!                               default case                             !
+-----------------------------------------------------------------------*/
    default:                           // we shouldn't get here
    {
        Common.Type = 'E';
        Common.ErrorType = -1;
        Common.Long = 901;             // Unknown function
        break;
    }
 }
            /*************************************
            *                                    *
            *       End of "Big Switch"          *
            *                                    *
            **************************************

/*-----------------------------------------------------------------------+
!+----------------------------------------------------------------------+!
!!                                                                      !!
!!   After doing the routine we free the allocated buffers and then     !!
!!   return the value.   However, if the rvalue is a string, return     !!
!!   it BEFORE freeing the buffers, because it might be in one of them. !!                              !
!!                                                                      !!
!+----------------------------------------------------------------------+!
+-----------------------------------------------------------------------*/

  if (Common.Type == 'S')     // String
  {
      L = ANSWERSTRING(Common.String);
  }

  if (Common.Type == 'A')     // Array
  {
      lpViperReturn->flt      = Common.Array.flt;
      lpViperReturn->x        = Common.Array.x;
      lpViperReturn->lpstr    = Common.Array.lpBuffer;
      lpViperReturn->inittype = VARTYPE_ARRAY;
      L = lpViperCallback(RESULT_SUCCESS, ViperInterfaceVersion, lpViperStruct, lpViperReturn);
      GlobalFree(Common.Array.lpBuffer);
  }

  if (Common.Borrowed) GlobalFree(Common.Buffer);

  if (Common.Type == 'S') return L;
  if (Common.Type == 'A') return L;
  if (Common.Type == 'L') { RETLONG(Common.Long); }
  if (Common.Type == 'E') { RETERROR(Common.ErrorType, Common.Long); }

                      // The type code could be wrong only if the
  RETERROR (-3,900);  // programmer really goofed.  However, knowing
                      // this programmer, we'd best allow for mistakes.

}
  /************************************
   *                                  *
   *    End of program WILExtender    *
   *                                  *
   ***********************************/








/*****************************************************************************
*                                 Atol                                       *
*                                                                            *
*         Converts a decimal character string to a long integer.             *
*****************************************************************************/

LONG NEARPASCAL Atol(LPSTR lpSource)
{
  LPSTR lpSrc;
  LONG  nNum;
  BOOL  bNegate;

  lpSrc = lpSource;
  bNegate = FALSE;
  nNum = 0;

  while (*lpSrc == ' ')
    lpSrc++;

  if (*lpSrc == '-' || *lpSrc == '+')
  {
    if (*lpSrc == '-')
      bNegate = TRUE;

    lpSrc++;
  }

  while (*lpSrc >= '0' && *lpSrc <= '9')
  {
    nNum = nNum * 10 + (*lpSrc - '0');
    lpSrc++;
  }

  if (bNegate)
    nNum = -nNum;

  return (nNum);
}


/*****************************************************************************
*                                    Ltoa                                    *
*                                                                            *
*  Converts a decimal integer to a string in any base (2 >= base >= 36).     *
*****************************************************************************/
void NEARPASCAL Ltoa(LONG nNum, LPSTR lpDest, UINT nBase)
{
  static char szConvert[37] = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
  static char szNum[30];
  LONG   nTemp;
  UINT   i, j;

  if (nNum == 0x80000000)
  {
    lstrcpy(lpDest, "-2147483648");
    return;
  }

  i = 0;
  j = 29;

  if (nNum < 0)
  {
    lpDest[i++] = '-';
    nNum = -nNum;
  }

  szNum[j--] = 0;

  do
  {
    nTemp = nNum % nBase;
    szNum[j--] = szConvert[(UINT) nTemp];
    nNum = nNum / nBase;
  }
  while(nNum);

  j++;
  lstrcpy(lpDest + i, szNum + j);

  return;
}



/*****************************************************************************
*                                 IsNumber                                   *
*                                                                            *
*  Returns TRUE if string consists of numeric characters (or leading +/-).   *
*****************************************************************************/

BOOL NEARPASCAL IsNumber(LPSTR lpSource)
{
  LPSTR lpSrc;

  lpSrc = lpSource;

  while (*lpSrc == ' ')                // skip over leading spaces
    lpSrc++;

  if ((*lpSrc == '-') || (*lpSrc == '+'))  // skip over leading '-' or '+'
    lpSrc++;

  while ((*lpSrc >= '0') && (*lpSrc <= '9'))
    lpSrc++;

  if (*lpSrc)                          // haven't reached the end: bad news
    return (FALSE);

  return (TRUE);
}

/*****************************************************************************
*                                 DebugMessage                               *
*                                                                            *
*   Displays a debug message in a MessageBox or on a debug monitor.          *
*****************************************************************************/

BOOL NEARPASCAL DebugMessage(HWND hWnd, LPSTR lpText, LPSTR lpTitle, BOOL bDebugMonitor)
{
  int  nReturn;

  if (bDebugMonitor)
  {
    OutputDebugString("\r\n");
    OutputDebugString(lpTitle);
    OutputDebugString("\r\n");
    OutputDebugString(lpText);
    OutputDebugString("\r\n");
    return (TRUE);
  }

  nReturn = MessageBox(hWnd, lpText, lpTitle, MB_ICONINFORMATION | MB_OKCANCEL);

  if (nReturn == IDCANCEL)
    return (FALSE);

  return (TRUE);
}
/****************************************************************************
*  Get a buffer.                                                            *
*                                                                           *
*  If the default buffer is long enough, return.                            *
*  Otherwise allocate a bigger one.                                         *
*                                                                           *
*  The Current buffer address is at  Common->Buffer                         *
*  The size of the buffer is at      Common->BuffSize                       *
*                                                                           *
*  Common->Borrowed is FALSE for the default buffer, but is set TRUE        *
*  when we allocate a new buffer.  (This flag will remind us that we need   *
*  to FREE the buffer at exit time.)                                        *
*                                                                           *
*  Note... We are passed the size of the longest string the buffer will     *
*  need to hold.  We must allocate size+1 bytes,  so there will be room     *
*  for the string and its terminating \0 character.                         *
****************************************************************************/
BOOL NEARPASCAL GetBuffer(xCommon *Common, long Size)
{

      if (Size < Common->BuffSize)           // If current buffer is big enough
           return (TRUE);                    // return with no change.

      if (Common->Borrowed)                  // Do we have a borrowed buffer?
      {                                      // If so, free it before we
           GlobalFree(Common->Buffer);       // borrow a new one.
           Common->Borrowed = FALSE;
      }

      Size = Size + 1;
      Common->Buffer = GlobalAlloc(GPTR,Size);   // Borrow memory.
      if (Common->Buffer == NULL)
      {
           Common->Type = 'E';
           Common->Long = 913;
           return FALSE;
      }
      Common->Borrowed = TRUE;
      Common->BuffSize = Size;
      return TRUE;
}


/*************************************************************************
*   Get the next word from a string.                                     *
*                                                                        *
*   Parameters...                                                        *
*                                                                        *
*      String  ... The string containing the word.                       *
*      DelimList.. The characters that delimit words in String.          *
*      Common .... An "xCommon" structure containing a buffer address    *
*                  The word is returned in the buffer.                   *
*                  (The Common parameter can be NULL if you don't        *
*                   need to have the word returned.)                     *
*      Delim ..... The address of a "char" where the delimiting          *
*                  character is returned.  This may be NULL if you       *
*                  don't need the delimiter returend.                    *
*                                                                        *
*   Return value is a pointer to the character after the delimiter.      *
*   or NULL if there is an error.                                        *
*                                                                        *
*  --------------------------------------------------------------------- *
*   If word starts with a quote, it ends with a quote,  Otherwise it     *
*   ends with the first character matching anything in DelimList.        *
*                                                                        *
*   If the word is delimited by spaces and non-blank, the non-blank      *
*   delimiter is always returned if present.                             *
*    ie...Suppose the delimiters are space or comma.                     *
*       if the words are "A B" then the delimiter is space               *
*       if the words are "A , B" then the delimiter is comma.            *
*                                                                        *
*   If the word ends with a quote, continue scanning to see if we can    *
*   find one of the (non blank) delimiters following the close-quote.    *
*                                                                        *
*   If space is a delimiter, multiple spaces are treated as a single     *
*   space. (No other delimiter is treated this way.)                     *
*                                                                        *
*************************************************************************/
char NEARPASCAL *GetWord(char *String, char *DelimList, xCommon *Common, char *Delim)
{
     char *Dx, *Begin, *End, *Out;
     char C, D, Q;
     BOOL Quoted;

     /*----------------------------------------+
     !    Skip leading spaces in the string    !
     +----------------------------------------*/
     while (1)
     {
         if (*String != ' ') break;
         String++;
     }

     /*----------------------------------------+
     !    If the string begins with a quote    !
     !    then look for the closing quote.     !
     +----------------------------------------*/
     Q = *String;
     if (Q == '\"' || Q == '\'')      // In Quotes?
     {
         Quoted = TRUE;
         String++;                    // Skip the opening quote
         Begin = String;              // Here's where the word begins.
         End = String;
         while (1)
         {
             End=String;               // Maybe this is the end?
             C = *String;              // Fetch Character
             if (C == '\0') break;     // Stop at end of string.
             String++;
             if (C == Q)               // Are we at a quote?
             {                          //   If yes, and next is not
                if (*String != Q) break; //    a quote, we're done.
                String++;
             }
         }
     }
     /*----------------------------------------+
     !    If string did NOT begin with quote   !
     !    then it continues until we find      !
     !    a character in the DelimList.        !
     +----------------------------------------*/
     else
     {
         Quoted = FALSE;
         Begin = String;               // Where our string begins
         while (1)
         {
            End = String;              // Adjust the end marker
            C = *String;               // Next Character
            if (C == '\0') break;      // Always stop at end of string.
            Dx = DelimList;            // Have we reached a delimiter?
            while ((D = *Dx++) != '\0')
                if (C == D) break;
            if (D != '\0') break;
            String++;
         }
     }

     /*----------------------------------------------+
     !   We need to find the real delimiter.         !
     !   If there is any non-blank character         !
     !   that's in our DelimList, that's the one.    !
     !   Otherwise, the delimiter is a space.        !
     +----------------------------------------------*/
     if (Delim != NULL) *Delim = ' '; // Assume delimiter is a space.
     while (1)
     {
         C = *String;            // If the delimiter is a space
         if (C != ' ') break;    // skip to next non-blank character.
         String++;
     }
     Dx = DelimList;             // Is the next character in the
     while ((D = *Dx++) != '\0') // delimiter list?
     {
         if (C == D)             // If so, return it.
         {
             if (Delim != NULL) *Delim = C;
             String++;           // point to character after delimiter.
             break;
         }
     }


     /*----------------------------------------------+
     !   If the user did not pass us the address     !
     !   of the common block, then she doesn't       !
     !   need the string returned.                   !
     +----------------------------------------------*/
     if (Common == NULL) return String;


     /*----------------------------------------------+
     !   Make sure the buffer is big enough.         !
     +----------------------------------------------*/
     if (!GetBuffer(Common, End - Begin))  return NULL;
     Out = Common->Buffer;

     /*----------------------------------------------+
     !   Fetch a word that's in quotes.              !
     +----------------------------------------------*/
     if (Quoted)
     {
         while (Begin < End)
         {
             C = *Begin++;           // Fetch Character.
             if (C == Q) Begin++;    // Change pair of quotes to one quote..
             *Out++ = C;
         }
     }

     /*----------------------------------------------+
     !   Fetch a word that's not in quotes.          !
     +----------------------------------------------*/
     else
     {
          while (End > Begin)
          {
             if (*(End-1) != ' ') break;  // Delete trailing spaces
             End--;
          }
          while (Begin < End)             // Copy the word
             *Out++ = *Begin++;
     }

     /*----------------------------------------------+
     !   Return                                      !
     +----------------------------------------------*/
     *Out = '\0';       // Terminate the word.
     return String;
}



/**************************************************************************
*    Put a string value into an array variable.                           *
*    Is passed the array pointer, and the string.                         *
*                                                                         *
*    Returns TRUE if successful.                                          *
*                                                                         *
*    If the operation fails, puts an error indicator in the Common block  *
*    and returns FALSE.                                                   *
**************************************************************************/

BOOL SetArrayString(xCommon *Common, LPARRVAR lpArray, char *TheString)
{
    lpArray->Ainittype = VARTYPE_STRING;
    lpArray->Astrptr = (DWORD) (*lpfnDllServices)(hBatData, 42, TheString, "", 0, 0);
    if ( lpArray->Astrptr == 0)
    {
       GlobalFree(Common->Array.lpBuffer);
       Common->Type = 'E';
       Common->ErrorType = -3;
       Common->Long = 104;
       return FALSE;
    }
    return TRUE;
}


void DebugType(char *Title, char Type)
  {
      char ShowMe[2];
      ShowMe[0] = Type;
      ShowMe[1] = '\0';
      MBSS(Title,ShowMe);
  }
